using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Text;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using BenLincoln.TheLostWorlds.CDTextures;
using VertexPNT = Microsoft.DirectX.Direct3D.CustomVertex.PositionNormalTextured;
using VertexPCT = Microsoft.DirectX.Direct3D.CustomVertex.PositionColoredTextured;

/*namespace ModelEx3
{
    class ModelExSRObject : ModelExObject
    {
        protected SR1File m_xSR1File;

        #region Render States

        protected override TextureOperation DefaultColorOperation
        {
            get
            {
                if (m_xSR1File == null ||
                    m_xSR1File.m_eFileType == FileType.Object)
                {
                    return TextureOperation.Modulate;
                }
                else
                {
                    return TextureOperation.Modulate4X;
                }
            }
        }
        protected override bool DefaultLighting
        {
            get
            {
                if (m_xSR1File == null ||
                    m_xSR1File.m_eFileType == FileType.Object)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }
        protected override ColorSource DefaultAmbientMaterialSource
        {
            get
            {
                if (m_xSR1File == null ||
                    m_xSR1File.m_eFileType == FileType.Object)
                {
                    return ColorSource.Material;
                }
                else
                {
                    return ColorSource.Color1;
                }
            }
        }
        protected override bool DefaultColorVertex
        {
            get
            {
                if (m_xSR1File == null ||
                    m_xSR1File.m_eFileType == FileType.Object)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }

        #endregion

        public override String TextureArchives
        {
            get
            {
                switch (m_xSR1File.m_ePlatform)
                {
                    case Platform.PC:
                        return
                            "Soul Reaver Monolithic Files (*.big)|*.big|" +
                            "All Files (*.*)|*.*";
                    case Platform.PSX:
                        return
                            "Soul Reaver CRM Files (*.crm)|*.crm|" +
                            "Soul Reaver Archive Files (*.dat)|*.dat|" +
                            "All Files (*.*)|*.*";
                    case Platform.Dreamcast:
                        return
                            "Soul Reaver Archive Files (*.vq)|*.vq|" +
                            "All Files (*.*)|*.*";
                    default:
                        return null;
                }
            }
        }

        public override String TextureArchiveExt
        {
            get
            {
                switch (m_xSR1File.m_ePlatform)
                {
                    case Platform.PC:           return "big";
                    case Platform.PSX:          return "crm";
                    case Platform.Dreamcast:    return "vq";
                    default:                    return null;
                }
            }
        }

        public ModelExSRObject(String strFileName, ref Device xDevice)
            : base(strFileName, ref xDevice)
        {
            // m_fScale = 0.0000335799f; // Same as Raziel
        }

        protected override void Load()
        {
            if (!m_bInitialised)
            {
                #region Initialise

                m_xSR1File = new SR1File(m_strFileName);

                // Set the file name
                m_strObjectName = m_xSR1File.m_strModelName.TrimEnd(new char[] { '_' });
                {
                    m_strObjectName.Trim();
                }

                for (int iModelIndex = 0; iModelIndex < m_xSR1File.m_usModelCount; iModelIndex++)
                {
                    // Create the container
                    ModelExFrame xFrame = new ModelExFrame();
                    m_xFrames.Add(xFrame);

                    xFrame.ModelExContainer = new ModelExContainer();
                    ModelExContainer xContainer = xFrame.ModelExContainer;
                    xContainer.Name = m_strObjectName + "_" + iModelIndex.ToString();

                    // Set the vertex format
                    VertexFormats eVertexFormat = (m_xSR1File.m_eFileType == FileType.Object) ?
                        VertexPNT.Format :
                        VertexPCT.Format;

                    // Create the Mesh
                    xContainer.Mesh = new Mesh(
                        (int)m_xSR1File.m_axModels[iModelIndex].PolygonCount,
                        (int)m_xSR1File.m_axModels[iModelIndex].IndexCount,
                        MeshFlags.Managed,
                        eVertexFormat,
                        m_xDevice
                    );

                    // Insert the vertices
                    if (eVertexFormat == VertexPNT.Format)
                    {
                        VertexPNT[] xVerticesPNT = new VertexPNT[m_xSR1File.m_axModels[iModelIndex].IndexCount];
                        for (UInt16 v = 0; v < m_xSR1File.m_axModels[iModelIndex].IndexCount; v++)
                        {
                            Vector3 xNormal = new Vector3();
                            xNormal.X = (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].normal.x;
                            xNormal.Y = (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].normal.z;
                            xNormal.Z = (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].normal.y;
                            xNormal.Normalize();

                            xVerticesPNT[v] = new VertexPNT(
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.x,
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.z,
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.y,
                                xNormal.X, // (float)m_xSR1File.m_axModels[iModelID].Vertices[v].normal.x,
                                xNormal.Y, // (float)m_xSR1File.m_axModels[iModelID].Vertices[v].normal.z,
                                xNormal.Z, // (float)m_xSR1File.m_axModels[iModelID].Vertices[v].normal.y,
                                m_xSR1File.m_axModels[iModelIndex].Vertices[v].fU,
                                m_xSR1File.m_axModels[iModelIndex].Vertices[v].fV
                            );
                        }
                        xContainer.Mesh.VertexBuffer.SetData(xVerticesPNT, 0, LockFlags.None);
                    }
                    else
                    {
                        VertexPCT[] xVerticesPCT = new VertexPCT[m_xSR1File.m_axModels[iModelIndex].IndexCount];
                        for (UInt16 v = 0; v < m_xSR1File.m_axModels[iModelIndex].IndexCount; v++)
                        {
                            xVerticesPCT[v] = new VertexPCT(
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.x,
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.z,
                                100f * (float)m_xSR1File.m_axModels[iModelIndex].Vertices[v].worldPos.y,
                                (int)m_xSR1File.m_axModels[iModelIndex].Vertices[v].colour,
                                m_xSR1File.m_axModels[iModelIndex].Vertices[v].fU,
                                m_xSR1File.m_axModels[iModelIndex].Vertices[v].fV
                            );
                        }
                        xContainer.Mesh.VertexBuffer.SetData(xVerticesPCT, 0, LockFlags.None);
                    }

                    // Insert the indices
                    UInt16[] iIndices = new UInt16[m_xSR1File.m_axModels[iModelIndex].IndexCount];
                    for (UInt16 i = 0; i < m_xSR1File.m_axModels[iModelIndex].IndexCount; i++)
                    {
                        if (m_xSR1File.m_axModels[iModelIndex].Indices[i] % 3 == 0)
                        {
                            iIndices[i] = m_xSR1File.m_axModels[iModelIndex].Indices[i];
                        }
                        if (m_xSR1File.m_axModels[iModelIndex].Indices[i] % 3 == 1)
                        {
                            iIndices[i] = m_xSR1File.m_axModels[iModelIndex].Indices[i + 1];
                        }
                        if (m_xSR1File.m_axModels[iModelIndex].Indices[i] % 3 == 2)
                        {
                            iIndices[i] = m_xSR1File.m_axModels[iModelIndex].Indices[i - 1];
                        }
                    }
                    xContainer.Mesh.IndexBuffer.SetData(iIndices, 0, LockFlags.None);

                    // Get the attributes
                    Int32[] axAttributeArray = xContainer.Mesh.LockAttributeBufferArray(LockFlags.Discard);
                    for (UInt16 p = 0; p < m_xSR1File.m_axModels[iModelIndex].PolygonCount; p++)
                    {
                        axAttributeArray[p] = m_xSR1File.m_axModels[iModelIndex].Polygons[p].material.ID;
                    }
                    xContainer.Mesh.UnlockAttributeBuffer(axAttributeArray);

                    // Weld any duplicate vertices
                    xContainer.Mesh.WeldVertices(
                        WeldEpsilonsFlags.WeldPartialMatches,
                        new WeldEpsilons(),
                        null
                    );

                    // Generate the adjacency
                    int[] aiAdjacency = new int[xContainer.Mesh.NumberFaces * 3];
                    xContainer.Mesh.GenerateAdjacency(0.0f, aiAdjacency);
                    xContainer.SetAdjacency(aiAdjacency);

                    // Compute the normals
                    if (m_xSR1File.m_eFileType == FileType.Area)
                    {
                        xContainer.Mesh = xContainer.Mesh.Clone(
                            MeshFlags.Managed,
                            xContainer.Mesh.VertexFormat | VertexFormats.Normal,
                            m_xDevice
                        );
                        xContainer.Mesh.ComputeNormals(aiAdjacency);
                    }

                    // Create the materials
                    ExtendedMaterial[] axExtendedMaterials = axExtendedMaterials = new ExtendedMaterial[m_xSR1File.m_axModels[iModelIndex].MaterialCount];
                    TextureData[] axTextureDescs = new TextureData[m_xSR1File.m_axModels[iModelIndex].MaterialCount];
                    for (UInt16 m = 0; m < m_xSR1File.m_axModels[iModelIndex].MaterialCount; m++)
                    {
                        Material xMaterial = new Material();
                        if (m_xSR1File.m_eFileType == FileType.Object &&
                            m_xSR1File.m_axModels[iModelIndex].Materials[m].textureUsed)
                        {
                            xMaterial.Diffuse = Color.White;
                        }
                        else
                        {
                            xMaterial.Diffuse = Color.FromArgb(
                                (Int32)(m_xSR1File.m_axModels[iModelIndex].Materials[m].colour)
                            );
                        }

                        String strTextureName = m_xSR1File.m_axModels[iModelIndex].Materials[m].textureName;

                        ExtendedMaterial xExtendedMaterial = new ExtendedMaterial();
                        xExtendedMaterial.Material3D = xMaterial;
                        xExtendedMaterial.TextureFilename = strTextureName;
                        axExtendedMaterials[m] = xExtendedMaterial;

                        TextureData xTextureDesc = null; //  m_xTextureFiles.Find(new FileDesc(strTextureName));
                        // if (xTextureDesc == null)
                        // {
                            xTextureDesc = new TextureData(strTextureName, null);
                            // m_xTextureFiles.Add(xTextureDesc);
                        //}
                        axTextureDescs[m] = xTextureDesc;
                    }
                    xContainer.SetMaterials(axExtendedMaterials);
                    xContainer.TextureDescs = axTextureDescs;

                    // Create the effects
                    EffectInstance[] axEffectInstances = new EffectInstance[m_xSR1File.m_axModels[iModelIndex].MaterialCount];
                    Effect[] axEffects = new Effect[m_xSR1File.m_axModels[iModelIndex].MaterialCount];
                    EffectData[] axEffectDescs = new EffectData[m_xSR1File.m_axModels[iModelIndex].MaterialCount];
                    xContainer.SetEffectInstances(axEffectInstances);
                    xContainer.Effects = axEffects;
                    xContainer.EffectDescs = axEffectDescs;
                    for (int e = 0; e < m_xSR1File.m_axModels[iModelIndex].MaterialCount; e++)
                    {
                        LoadEffect(iModelIndex, e);
                    }
                }

                #endregion

                m_bInitialised = true;
            }
        }

        public override void LoadTexturesFromFile(String strFileName, int iModelIndex)
        {
            switch (m_xSR1File.m_ePlatform)
            {
                case Platform.PC:
                    LoadTexturesFromPCMonolithicFile(strFileName, iModelIndex);
                    break;
                case Platform.PSX:
                    LoadTexturesFromCRM(strFileName, iModelIndex);
                    break;
                case Platform.Dreamcast:
                    LoadTexturesFromDCMonolithicFile(strFileName, iModelIndex);
                    break;
            }
        }

        protected void LoadTexturesFromCRM(String strFilePath, int iModelIndex)
        {
            ModelExContainer xContainer = m_xFrames[iModelIndex].ModelExContainer;
            SR1Model xModel = m_xSR1File.m_axModels[iModelIndex];

            // Copy the polygon data for texturing
            SoulReaverPlaystationTextureFile.SoulReaverPlaystationPolygonTextureData[] xPolygons =
                new SoulReaverPlaystationTextureFile.SoulReaverPlaystationPolygonTextureData[m_xSR1File.m_axModels[iModelIndex].PolygonCount];

            int polyNum = 0;
            foreach (ExPolygon xPolygon in xModel.Polygons)
            {
                xPolygons[polyNum].paletteColumn = xPolygon.paletteColumn;
                xPolygons[polyNum].paletteRow = xPolygon.paletteRow;
                xPolygons[polyNum].u = new int[3];
                xPolygons[polyNum].v = new int[3];
                xPolygons[polyNum].u[0] = (int)xPolygon.v1.u;
                xPolygons[polyNum].u[1] = (int)xPolygon.v2.u;
                xPolygons[polyNum].u[2] = (int)xPolygon.v3.u;
                xPolygons[polyNum].v[0] = (int)xPolygon.v1.v;
                xPolygons[polyNum].v[1] = (int)xPolygon.v2.v;
                xPolygons[polyNum].v[2] = (int)xPolygon.v3.v;
                xPolygons[polyNum].textureID = xPolygon.material.textureID;
                polyNum++;
            }

            SoulReaverPlaystationTextureFile xTextureFile = null;
            for (int m = 0; m < xModel.Materials.Length; m++)
            {
                ExMaterial xMaterial = xModel.Materials[m];
                if (xMaterial.textureUsed)
                {
                    TextureData xTextureDesc = m_xTextureFiles.Find(new FileData(xMaterial.textureName));

                    if (xTextureDesc == null)
                    {
                        if (xTextureFile == null)
                        {
                            xTextureFile = new SoulReaverPlaystationTextureFile(strFilePath);
                            xTextureFile.BuildTexturesFromPolygonData(xPolygons, false, true);
                        }

                        Texture xTexture = xTextureFile.GetTexture(m_xDevice, xMaterial.textureID);
                        xTextureDesc = new TextureData(xMaterial.textureName, xTexture);
                        m_xTextureFiles.Add(xTextureDesc);
                    }

                    xContainer.TextureDescs[m] = xTextureDesc;
                }
            }
        }

        public bool LoadTexturesFromPCMonolithicFile(String strFilePath, int iModelIndex)
        {
            ModelExContainer xContainer = m_xFrames[iModelIndex].ModelExContainer;
            SR1Model xModel = m_xSR1File.m_axModels[iModelIndex];

            SoulReaverPCTextureFile xTextureFile = new SoulReaverPCTextureFile(strFilePath);
            for (int m = 0; m < xModel.Materials.Length; m++)
            {
                ExMaterial xMaterial = xModel.Materials[m];
                if (xMaterial.textureUsed)
                {
                    TextureData xTextureDesc = m_xTextureFiles.Find(new FileData(xMaterial.textureName));

                    if (xTextureDesc == null)
                    {
                        Texture xTexture = xTextureFile.GetTexture(m_xDevice, xMaterial.textureID);
                        xTextureDesc = new TextureData(xMaterial.textureName, xTexture);
                        m_xTextureFiles.Add(xTextureDesc);
                    }

                    xContainer.TextureDescs[m] = xTextureDesc;
                }
            }
            return true;
        }

        public bool LoadTexturesFromDCMonolithicFile(String strFilePath, int iModelIndex)
        {
            ModelExContainer xContainer = m_xFrames[iModelIndex].ModelExContainer;
            SR1Model xModel = m_xSR1File.m_axModels[iModelIndex];

            SoulReaverDreamcastTextureFile xTextureFile = new SoulReaverDreamcastTextureFile(strFilePath);
            for (int m = 0; m < xModel.Materials.Length; m++)
            {
                ExMaterial xMaterial = xModel.Materials[m];
                if (xMaterial.textureUsed)
                {
                    TextureData xTextureDesc = m_xTextureFiles.Find(new FileData(xMaterial.textureName));

                    if (xTextureDesc == null)
                    {
                        Texture xTexture = xTextureFile.GetTexture(m_xDevice, xMaterial.textureID);
                        xTextureDesc = new TextureData(xMaterial.textureName, xTexture);
                        m_xTextureFiles.Add(xTextureDesc);
                    }

                    xContainer.TextureDescs[m] = xTextureDesc;
                }
            }
            return true;
        }
    }
}*/